package de.tu_dresden.lat.dlProofChecking.proofsProcessing

import java.io.{File, PrintWriter}

import de.tu_dresden.lat.dlProofChecking.lispFormatting.Proof2LISPFormatter
import de.tu_dresden.lat.proofs.interfaces.{IProof, IProofGenerator}
import de.tu_dresden.lat.proofs.json.JsonProofWriter
import org.semanticweb.owlapi.model.OWLOntology
import org.semanticweb.owlapi.reasoner.OWLReasonerFactory

/**
 * Generate a certificate for the class hierarhcy generated by a reasoner
 * @param proofGenerator
 */
class CertificateGenerator(reasonerFactory: OWLReasonerFactory, proofGenerator: IProofGenerator)
extends ProofsProcessor(reasonerFactory, proofGenerator) {

  var output: PrintWriter = _
  var proofWriter: Proof2LISPFormatter = _
  var proofWriter2 = new JsonProofWriter()

  def generateCertificate(ontology: OWLOntology, file: File) = {
    output = new PrintWriter(file)

    proofWriter = new Proof2LISPFormatter(ontology);

    proofGenerator.setOntology(ontology)

    processOntology(ontology)

    output.close()
  }

  override protected def check(proof: IProof): Unit = {
    //println("Proof in JSON:")
    //println(proofWriter2.toString(proof))
    output.println(proofWriter.toString(proof))
    //          println(proofWriter.toString(proof))
  }
}
