package de.tu_dresden.lat.dlProofChecking.tools

import java.io.File

import scala.collection.JavaConverters._
import org.semanticweb.owlapi.apibinding.OWLManager
import org.semanticweb.owlapi.model.{OWLClass, OWLEquivalentClassesAxiom, OWLObjectIntersectionOf, OWLObjectPropertyDomainAxiom, OWLObjectSomeValuesFrom, OWLOntology, OWLPropertyRangeAxiom, OWLSubClassOfAxiom, OWLSubObjectPropertyOfAxiom, OWLSubPropertyChainOfAxiom, OWLTransitiveObjectPropertyAxiom}
import org.semanticweb.owlapi.model.parameters.Imports


object CheckOntologySupported {
  def main(args: Array[String]) = {
    print(args(0)+" ")
    val ontology = OWLManager.createOWLOntologyManager().loadOntologyFromOntologyDocument(new File(args(0)))

    if(supported(ontology))
      println("supported")
    else
      println("not supported")
  }

  def supported(ontology: OWLOntology) =
    ontology.tboxAxioms(Imports.INCLUDED).iterator().asScala.forall{ ax =>
      val result =
      (ax.isInstanceOf[OWLSubClassOfAxiom]
        || ax.isInstanceOf[OWLEquivalentClassesAxiom]
        || ax.isInstanceOf[OWLSubObjectPropertyOfAxiom]
        || ax.isInstanceOf[OWLSubPropertyChainOfAxiom]
        || ax.isInstanceOf[OWLObjectPropertyDomainAxiom]
        || ax.isInstanceOf[OWLTransitiveObjectPropertyAxiom] )
      if(!result)
        print(ax+" ")
      result &&
  ax.nestedClassExpressions().iterator().asScala.forall { cl =>
    val result = cl.isInstanceOf[OWLClass] ||
      cl.isInstanceOf[OWLObjectIntersectionOf] ||
      cl.isInstanceOf[OWLObjectSomeValuesFrom] ||
      cl.isOWLThing ||
      cl.isOWLNothing
    if(!result)
      print(cl+" ")
    result
  }}
}
