package de.tu_dresden.lat.dlProofChecking.tools

import de.tu_dresden.lat.proofs.interfaces.{IInference, IProof}
import org.semanticweb.owlapi.model.OWLAxiom

import scala.collection.JavaConverters._

object ProofTools {

  def axioms(proof: IProof) = {
    proof.getInferences()
      .asScala
      .toSet
      .flatMap((x: IInference) => x.getPremises().asScala.toSet[OWLAxiom])
  }

  def assertedAxiomsUsed(proof: IProof) = {
    proof.getInferences
      .asScala
      .toSet
      .filter(_.getRuleName()=="Asserted Conclusion")
      .map(_.getConclusion)
  }

  def classesInSignature(proof: IProof) =
    axioms(proof).flatMap(_.classesInSignature().iterator().asScala)

  def objectPropertiesInSignature(proof: IProof) =
    axioms(proof).flatMap(_.objectPropertiesInSignature().iterator().asScala)
}
